/* 
 * sim_ether_i.h
 *
 * x-kernel v3.3
 *
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 *
 * $Revision: 1.11 $
 * $Date: 1997/04/29 22:47:21 $
 */

#define SIMETH_MAX_INSTANCES	5
#define MAX_ETH_SIZE (EMAXPAK+sizeof(ETHhdr))

#define MAX_ERROR_COUNT 1000

#define RCVBUFSIZE 	50*1024		
#define EMAXPAK 	(MAX_ETH_DATA_SZ + sizeof(ETHhdr))

/*
 * The MTU is tuned to minimize number of socket reads in ping-pong tests
 * at packet sizes of 8000, 16000, etc.  Note that
 *
 *   42 bytes (for sim driver) =   14 bytes (for SIMETH MAC overhead) +
 *                                  8 bytes (for IRIX UDP header) +
 *                                 20 bytes (for IRIX IP header)
 */

#define ETH_MTU_SIZE    (MAX_ETH_DATA_SZ - 42)


typedef struct {
    char	*buf;
    int		len;
    int		sock;
} EthMsg;

typedef struct {
    Protl	arp;
    int		sock;
    int		port;
    ETHhost	myHost;
    int		errorCount;
    int         mtu;
} PState;
